var R rk pik pic piq w F c L y e k I q s sk g;
var dy di dl de infobs iobs e1 e2 a;

predetermined_variables k;

varexo es esk eg ee1 ee2 errora;

parameters beta delta phi x phipi phiy alphae alphak alphal theta epsilon omega Sbar Skbar Abar
           rhog rhos rhosk rho1 rho2 rho22 rhoa rhoag;

delta = 0.025;
omega = 0.18;
epsilon = 8;
x = 0.023;
beta = 0.99;
phi = 1.17; % Jesus et Ramires


// Parameters to estimate
phipi = 1.2;
phiy = 0.5;
theta = 0.65;


// Parameters to estimate
phipi = 1.2;
phiy = 0.5;
rhog = 0.8;
rhos = 0.8;
rhosk = 0.8;
rho22 = 0.8;
rhoa = 0.8;
rho1 = 0.8;
rho2 = 0.8;
rhoag = 0.8;
phi = 1.17;


sigmas=1;
sigmag=1;
sigmask=1;
sigmaee1=1;
sigmaee2=1;
sigmaerrora = 1;


// derived from steady state
Skbar = 1;
Sbar = 0.47; // Mean of the real price of oil
Abar = 1;
 

model(linear);
#markup = ((epsilon-1)/epsilon);
%#alphae = alpha-alphal+alphak;
#alpha = alphae+(alphal+alphak);
#rkss = 1/beta - 1 + delta;
#Lbar = (markup*alphal*((1-omega-(alphae*markup)*(1+(alphak*delta)/(alphae*rkss)))^(-1)))^(1/(1+phi));
#Qbar=(Abar*(Lbar^alphal)*((markup*alphae/Sbar)^(alphak+alphae))*(((Sbar*alphak)/(Skbar*alphae*rkss))^(alphak)))^(1/(1-alphak-alphae));
#Cbar=(1/Sbar^x)*(1-omega-(alphae*((epsilon-1))/epsilon)*(1+(alphak*delta)/(alphae*rkss)))*Qbar;
#Ibar = delta*(alphak/(Skbar*rkss))*(epsilon-1)/epsilon*Qbar;
#Ebar = (alphae/Sbar)*markup*Qbar;
#Gbar = omega*Qbar;
#Ybar = Sbar^(-x)*(Qbar - Sbar*Ebar);

R = (1-beta*(1-delta))*(rk(+1)) + pik(+1);
c = c(+1) - (R-pic(+1));
w = c + phi*L+x*s;
L + w = s + e;
L + w = rk + sk + k;
(Sbar^x*Cbar)*(c+x*s) + (Skbar*Ibar)*(sk + I) + g = Qbar * q - (Sbar*Ebar)*(s+e);
delta*I = k(+1) - (1-delta)*k;

R = phipi*piq + phiy*y + e1;
q = a + alphal*L + alphae*(e) + alphak*k;
piq = beta*piq(+1) + ((1-beta*theta)*(1-theta)*alpha)/(theta*(alpha+(1-alpha)*epsilon))*((1-alpha)/alpha*q + F) + e2;
F = -(1/alpha)*( a - alphae*(s)-alphal*w-alphak*(rk+sk));
pic = piq + x*(s-s(-1));
pik = piq + (sk-sk(-1));
(Sbar^x*Ybar)*(y+x*s) = Qbar * q - (Sbar*Ebar)*(s+e);

e1 = rho1*e1(-1) + ee1;
e2 = rho2*e2(-1) + ee2 - rho22*ee2(-1);
a = rhoa*a(-1) + errora;
g = rhog*g(-1)+ rhoag*errora + eg;
s = rhos*s(-1) + es;
sk = rhosk*sk(-1) + esk;

// Variables of the measurement equation
dy = y ;
di = I + sk - x*(s);
dl = L;
de = e;
infobs = pic;
iobs = R;
end; 

shocks;
var es; stderr sigmas;
var esk; stderr sigmask;
var eg; stderr sigmag;
var ee1; stderr sigmaee1;
var ee2; stderr sigmaee2;
var errora; stderr sigmaerrora;
end;

varobs de dy di dl infobs iobs;

estimated_params;
alphak, 0.3,0,1, inv_gamma_pdf, 0.3, 2;
alphal,0.6,0,1, inv_gamma_pdf, 0.6, 2;
alphae,0.2,0,1, inv_gamma_pdf, 0.2, 2;

rhog,0.8,0,1,BETA_PDF,0.5,0.20;
rhoag,0.8,0,1,BETA_PDF,0.5,0.20;
rhos,0.8,0,1,BETA_PDF,0.5,0.20;
rhosk,0.8,0,1,BETA_PDF,0.5,0.20;
rho1,0.8,0,1,BETA_PDF,0.5,0.20;
rho2,0.8,0,1,BETA_PDF,0.5,0.20;
rho22,0.8,0,1,BETA_PDF,0.5,0.20;
rhoa,0.8,0,1, BETA_PDF, 0.5, 0.20;

stderr es,0.8,0,2, inv_gamma_pdf, 1, 2;
stderr esk,0.8,0,2, inv_gamma_pdf, 1, 2;
stderr eg,0.8,0,2, inv_gamma_pdf, 1, 2;
stderr ee1,0.8,0,2, inv_gamma_pdf,1, 2;
stderr ee2,0.8,0,2, inv_gamma_pdf, 1, 2;
stderr errora,0.8,0,2, inv_gamma_pdf, 1, 2;

phi,1.17,0.2,2, inv_gamma_PDF, 1.17, 0.5;
phipi,1.5,1,5, normal_pdf, 1.2, 0.1;
phiy,0.5,0,1, normal_pdf, 0.5, 0.1;
%theta,0.8,0.5,1, beta_pdf, 0.65, 0.2;

end;


estimation(datafile = estimation, nodisplay, plot_priors = 0 ,mode_compute=6) ;